// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];
var snsridHasIPMI =            parent.asID['DUMMY_SENSORID_HASIPMI'];

var snridMBTemperature1 =      (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridMBTemperature2 =      (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0150;
var snridCPU1Temperature1 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0110;
var snridCPU2Temperature1 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0120;

var snridVcore1Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;
var snridVcore2Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0120;

var snridFan1Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0110;
var snridFan2Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0120;
var snridFan3Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0130;
var snridFan4Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0140;
var snridFan5Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0150;
var snridFan6Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0160;
var snridFan7Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0170;
var snridFan8Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0180;
var snridFan9Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0190;
var snridFan10Speed =          (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x01A0;
var snridFan11Speed =          (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x01B0;
var snridFan12Speed =          (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x01C0;

var snridBkplBay1Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1110;
var snridBkplBay2Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1120;
var snridBkplBay3Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1130;
var snridBkplBay4Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1140;

var snridPower1Plug =          (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x2110;
var snridPower2Plug =          (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x2210;
var snridPower1DC =            (parent.asID['ASWM_SNRTYPE_POWER'] << 16) + 0x2110;
var snridPower2DC =            (parent.asID['ASWM_SNRTYPE_POWER'] << 16) + 0x2210;
var snridPower1AC =            (parent.asID['ASWM_SNRTYPE_POWER'] << 16) + 0x2120;
var snridPower2AC =            (parent.asID['ASWM_SNRTYPE_POWER'] << 16) + 0x2220;
var snridPowerFan1 =           (parent.asID['ASWM_SNRTYPE_POWERFANSTATUS'] << 16) + 0x2130;
var snridPowerFan2 =           (parent.asID['ASWM_SNRTYPE_POWERFANSTATUS'] << 16) + 0x2230;


var compFan1 = new SysComponentInfo ('FAN1', "parent.once.GSensorNames[parent.once.snridFan1Speed]", 'info_fan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan1Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan1Speed).unit]", snridFan1Speed)
    )
);
var compFan2 = new SysComponentInfo ('FAN2', "parent.once.GSensorNames[parent.once.snridFan2Speed]", 'info_fan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan2Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan2Speed).unit]", snridFan2Speed)
    )
);
var compFan3 = new SysComponentInfo ('FAN3', "parent.once.GSensorNames[parent.once.snridFan3Speed]", 'info_fan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan3Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan3Speed).unit]", snridFan3Speed)
    )
);
var compFan4 = new SysComponentInfo ('FAN4', "parent.once.GSensorNames[parent.once.snridFan4Speed]", 'info_fan3.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan4Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan4Speed).unit]", snridFan4Speed)
    )
);
var compFan5 = new SysComponentInfo ('FAN5', "parent.once.GSensorNames[parent.once.snridFan5Speed]", 'info_fan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan5Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan5Speed).unit]", snridFan5Speed)
    )
);
var compFan6 = new SysComponentInfo ('FAN6', "parent.once.GSensorNames[parent.once.snridFan6Speed]", 'info_fan3.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan6Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan6Speed).unit]", snridFan6Speed)
    )
);
var compFan7 = new SysComponentInfo ('FAN7', "parent.once.GSensorNames[parent.once.snridFan7Speed]", 'info_fan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan7Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan7Speed).unit]", snridFan7Speed)
    )
);
var compFan8 = new SysComponentInfo ('FAN8', "parent.once.GSensorNames[parent.once.snridFan8Speed]", 'info_fan3.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan8Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan8Speed).unit]", snridFan8Speed)
    )
);
var compFan9 = new SysComponentInfo ('FAN9', "parent.once.GSensorNames[parent.once.snridFan9Speed]", 'info_fan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan9Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan9Speed).unit]", snridFan9Speed)
    )
);
var compFan10 = new SysComponentInfo ('FAN10', "parent.once.GSensorNames[parent.once.snridFan10Speed]", 'info_fan3.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan10Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan10Speed).unit]", snridFan10Speed)
    )
);
var compFan11 = new SysComponentInfo ('FAN11', "parent.once.GSensorNames[parent.once.snridFan11Speed]", 'info_fan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan11Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan11Speed).unit]", snridFan11Speed)
    )
);
var compFan12 = new SysComponentInfo ('FAN12', "parent.once.GSensorNames[parent.once.snridFan12Speed]", 'info_fan3.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan12Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan12Speed).unit]", snridFan12Speed)
    )
);


var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_board.jpg',
    new Tuple (
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature1]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature1).unit]", snridMBTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature2]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature2).unit]", snridMBTemperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).unit]", snridCPU1Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).unit]", snridCPU2Temperature1)
    )
);


var compMemory;
var compMemory2;
if (parent.once.hasNewSmBiosMemFeature) {
    compMemory = new SysComponentInfo ('DIMM1', "parent.I18N['RAMMODULE']", 'info_ddr1.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYARRAY']", "parent.once.findDMI(parent.once.theDMIPhyscalMemArray, 1, 6).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 12).value", 
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 8).value)", snsridHasDMI)
           
        )
    );
    compMemory2 = new SysComponentInfo ('DIMM2', "parent.I18N['RAMMODULE']", 'info_ddr2.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYARRAY']", "parent.once.findDMI(parent.once.theDMIPhyscalMemArray, 1, 6).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 5, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 6, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 7, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 12).value", 
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 8, 8).value)", snsridHasDMI)
        )
    );

} else {
    compMemory = new SysComponentInfo ('DIMM1', "parent.I18N['RAMMODULE']", 'info_ddr1.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI)
        )
    );
    compMemory2 = new SysComponentInfo ('DIMM2', "parent.I18N['RAMMODULE']", 'info_ddr2.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 5, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 5, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 6, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 6, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 7, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 7, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 8, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 8, 9).value)", snsridHasDMI)
        )
    );
}

var compCPU1 = new SysComponentInfo ('CPU1', "parent.I18N['CPU'] + ' 1'", 'info_cpu1.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcore1Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature1).unit]", snridCPU1Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore1Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).unit]", snridVcore1Voltage)
    )
);
var compCPU2 = new SysComponentInfo ('CPU2', "parent.I18N['CPU'] + ' 2'", 'info_cpu2.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 2, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 2, 13).value + 'Mhz'", snridVcore2Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature1]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature1).unit]", snridCPU2Temperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore2Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).unit]", snridVcore2Voltage)
    )
);

var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "2"),
        new triple ("parent.I18N['MAN_LAN_PORT']", "'1 ' + parent.I18N['OPTIONAL_PORT']"),
        new triple ("parent.I18N['USB_PORT']", "2")
    )
);

var compBackplaneBoard = new SysComponentInfo ('BACKPLANEBOARD', "parent.I18N['BACKPLANE']", 'info_bp.jpg',
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "parent.once.findFRU(17, 2, 6)", snsridHasFRU)
    )
);
var compBackplane = new SysComponentInfo ('BACKPLANE', "parent.I18N['BACKPLANE']",
    new SysCompositeImage (
        'IBACKPLANE',
        new Tuple (
            '"<TABLE WIDTH=\\"270\\" height=\\"160\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD colspan=\\"6\\" WIDTH=\\"270\\" height=\\"104\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_01.gif\\"></TD></TR>"',
            '"<TR><TD width=\\"23\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_02.gif\\"></TD>"',
            '"    <TD width=\\"56\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay1Plug).currvalue == 1 ? "hd_ok" : "hd_no1") + ".gif\\"></TD>"',
            '"    <TD width=\\"56\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay2Plug).currvalue == 1 ? "hd_ok" : "hd_no2") + ".gif\\"></TD>"',
            '"    <TD width=\\"56\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay3Plug).currvalue == 1 ? "hd_ok" : "hd_no3") + ".gif\\"></TD>"',
            '"    <TD width=\\"56\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay4Plug).currvalue == 1 ? "hd_ok" : "hd_no4") + ".gif\\"></TD>"',
            '"    <TD width=\\"23\\" height=\\"16\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_03.gif\\"></TD></TR>"',
            '"<TR><TD colspan=\\"6\\" WIDTH=\\"270\\" height=\\"85\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_04.gif\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "parent.once.findFRU(17, 2, 6)", snsridHasFRU),
        new triple ("parent.I18N['HARDDISK_NUMBER']",
            "parent.once.GSensors.idAt(parent.once.snridBkplBay1Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay2Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay3Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay4Plug).currvalue",
            "parent.once.GSensors.idAt(parent.once.snridBkplBay1Plug).currstatus | " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay2Plug).currstatus | " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay3Plug).currstatus | " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay4Plug).currstatus"
        )
    ),
    new Tuple (
        new triple ('IALARM_BACKPLANE_BAY1',
            new triple (new Point (-5, 105), '"<img src=\\"" + parent.once.imgPath + "HD_e1.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay1Plug)
        ),
        new triple ('IALARM_BACKPLANE_BAY2',
            new triple (new Point (65, 105), '"<img src=\\"" + parent.once.imgPath + "HD_e2.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay2Plug)
        ),
        new triple ('IALARM_BACKPLANE_BAY3',
            new triple (new Point (135, 105), '"<img src=\\"" + parent.once.imgPath + "HD_e3.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay3Plug)
        ),
        new triple ('IALARM_BACKPLANE_BAY4',
            new triple (new Point (191, 105), '"<img src=\\"" + parent.once.imgPath + "HD_e4.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay4Plug)
        )
    )
);

var compRedundantPower = new SysComponentInfo ('RDTPOWER', "parent.I18N['POWER']",
    new SysCompositeImage (
        'IPOWER',
        new Tuple(
            '"<TABLE WIDTH=\\"270\\" height=\\"205\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"102\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "power_01.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"66\\" height=\\"39\\"><IMG SRC=\\"" + parent.once.imgPath + "power_02.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"105\\" height=\\"39\\">"',
            '"        <TABLE WIDTH=\\"138\\" height=\\"39\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"        <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridPower1Plug).currvalue == 1 ? "power_ok" : "power_noL") + ".gif\\" BORDER=\\"0\\"></TD>"',
            '"            <TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridPower2Plug).currvalue == 1 ? "power_ok" : "power_noR") + ".gif\\" BORDER=\\"0\\"></TD></TR></TABLE></TD>"',
            '"    <TD WIDTH=\\"66\\" height=\\"39\\"><IMG SRC=\\"" + parent.once.imgPath + "power_03.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"64\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "power_04.gif\\" BORDER=\\"0\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['POWERMODULE'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower1Plug))", snridPower1Plug),
        new triple ("parent.I18N['POWERMODULE'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower2Plug))", snridPower2Plug),
        new triple ("parent.I18N['POWER_FAN'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan1))", snridPowerFan1),
        new triple ("parent.I18N['POWER_FAN'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan2))", snridPowerFan2),
        new triple ("parent.I18N['POWERDC'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower1DC))", snridPower1DC),
        new triple ("parent.I18N['POWERDC'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower2DC))", snridPower2DC),
        new triple ("parent.I18N['POWERCORD'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower1AC))", snridPower1AC),
        new triple ("parent.I18N['POWERCORD'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower2AC))", snridPower2AC)
    ),
    new Tuple (
        new triple ('IALARM_POWERPLUG_LEFT',
            new triple (new Point (54, 102), '"<img src=\\"" + parent.once.imgPath + "power_eL.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower1Plug)
        ),
        new triple ('IALARM_POWERPLUG_RIGHT',
            new triple (new Point (134, 102), '"<img src=\\"" + parent.once.imgPath + "power_eR.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower2Plug)
        ),
        new triple ('IALARM_POWERAC_LEFT',
            new triple (new Point (54, 102), '"<img src=\\"" + parent.once.imgPath + "plug_eL.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower1AC)
        ),
        new triple ('IALARM_POWERAC_RIGHT',
            new triple (new Point (134, 102), '"<img src=\\"" + parent.once.imgPath + "plug_eR.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower2AC)
        )
    )
);

var compRiser = new SysComponentInfo ('RISER', "parent.I18N['RISERBOARD']", 'info_riser.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 2, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 2, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 7).extra", snsridHasDMI)
    )
);

var compIPMI = new SysComponentInfo ('IPMI', "'IPMI'",
    new SysCompositeImage (
        'IPMI',
        new Tuple (
            '"<img src=\\"" + parent.once.imgPath + (parent.once.findIPMI(parent.once.theASMAInfo, 16) ? "info_ipmi_2.jpg" : "info_ipmi.jpg") + "\\">"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['IPMI_CARDTYPE']", "parent.once.findIPMI(parent.once.theASMAInfo, 16)", snsridHasIPMI)
    )
);


var theSystemComponents = new Tuple (
    compBackplane,
    compBackplaneBoard,
    compIOConnector,
    compRiser,
	compRedundantPower,
    compFan1,
    compFan2,
    compFan3,
    compFan4,
    compFan5,
    compFan6,
    compFan7,
    compFan8,
    compFan9,
    compFan10,
    compFan11,
    compFan12,
    compMotherboard,
    compIPMI,
    compMemory,
    compMemory2,
    compCPU1,
    compCPU2
);


//////////////////////////////////////////////
// The System with Views

var imgPath = './img/rs163-e4_rx4/';
var imgPanelRear = 'main_rear.gif';
var imgPanelTop = 'main_top.gif';
var imgPanelFront = 'main_front.gif';
var theSystem = new SysModel ('model.jpg', chassis_rackmount);

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('f',
    new SysModelView (parent.I18N['FRONT_VIEW'], parent.I18N['FRONT'],
        'view_front_o.jpg', 'view_front.jpg', 'info_front.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 12, 181, 263, 202), compBackplane)
        ),
        new Tuple (
            new quadruple ('AL_BACKPLANE', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (128, 183))
        )
    )
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect (136,  36, 148,  63), compIPMI),
            new AnArea (new Rect ( 26, 157, 158, 168), compBackplaneBoard),
			new AnArea (new Rect ( 26, 170, 158, 216), compBackplane),
            new AnArea (new Rect ( 25,  10,  74, 113), compRedundantPower),
            new AnArea (new Rect ( 36, 135,  51, 156), compFan1),
            new AnArea (new Rect ( 50, 135,  65, 156), compFan2),
            new AnArea (new Rect ( 86, 145, 100, 156), compFan3),
            new AnArea (new Rect ( 86, 135, 100, 146), compFan4),
            new AnArea (new Rect (101, 145, 115, 156), compFan5),
            new AnArea (new Rect (101, 135, 115, 146), compFan6),
            new AnArea (new Rect (114, 145, 128, 156), compFan7),
            new AnArea (new Rect (114, 135, 128, 146), compFan8),
            new AnArea (new Rect (128, 145, 142, 156), compFan9),
            new AnArea (new Rect (128, 135, 142, 146), compFan10),
            new AnArea (new Rect (143, 145, 157, 156), compFan11),
            new AnArea (new Rect (143, 135, 157, 146), compFan12),
            new AnArea (new Rect (105,  17, 122,  74), compRiser),
            new AnArea (new Rect ( 78,  82,  96, 130), compMemory),
            new AnArea (new Rect (145,  82, 163, 130), compMemory2),
            new AnArea (new Rect (124,  91, 144, 113), compCPU2),
            new AnArea (new Rect (100,  91, 121, 113), compCPU1),
            new AnArea (new Rect ( 75,  11, 159, 134), compMotherboard)
        ),
        new Tuple (
            new quadruple ('AL_POWERS', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_POWERS'], new Point (40, 53)),
            new quadruple ('AL_FAN1', parent.asID['IDV_TYPE_SNR'], snridFan1Speed,   new Point ( 34, 137)),
            new quadruple ('AL_FAN2', parent.asID['IDV_TYPE_SNR'], snridFan2Speed,   new Point ( 48, 137)),
            new quadruple ('AL_FAN3', parent.asID['IDV_TYPE_SNR'], snridFan3Speed,   new Point ( 84, 142)),
            new quadruple ('AL_FAN4', parent.asID['IDV_TYPE_SNR'], snridFan4Speed,   new Point ( 84, 132)),
            new quadruple ('AL_FAN5', parent.asID['IDV_TYPE_SNR'], snridFan5Speed,   new Point ( 99, 142)),
            new quadruple ('AL_FAN6', parent.asID['IDV_TYPE_SNR'], snridFan6Speed,   new Point ( 99, 132)),
            new quadruple ('AL_FAN7', parent.asID['IDV_TYPE_SNR'], snridFan7Speed,   new Point (112, 142)),
            new quadruple ('AL_FAN8', parent.asID['IDV_TYPE_SNR'], snridFan8Speed,   new Point (112, 132)),
            new quadruple ('AL_FAN9', parent.asID['IDV_TYPE_SNR'], snridFan9Speed,   new Point (126, 142)),
            new quadruple ('AL_FAN10', parent.asID['IDV_TYPE_SNR'], snridFan10Speed, new Point (126, 132)),
            new quadruple ('AL_FAN11', parent.asID['IDV_TYPE_SNR'], snridFan11Speed, new Point (141, 142)),
            new quadruple ('AL_FAN12', parent.asID['IDV_TYPE_SNR'], snridFan12Speed, new Point (141, 132)),
            new quadruple ('AL_CPU1TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature1, new Point (102, 94)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcore1Voltage,       new Point (102, 94)),
            new quadruple ('AL_CPU2TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPU2Temperature1, new Point (125, 94)),
            new quadruple ('AL_VCORE2', parent.asID['IDV_TYPE_SNR'], snridVcore2Voltage,       new Point (125, 94)),
            new quadruple ('AL_MBTEMP1', parent.asID['IDV_TYPE_SNR'], snridMBTemperature1, new Point (108, 76)),
            new quadruple ('AL_MBTEMP2', parent.asID['IDV_TYPE_SNR'], snridMBTemperature2, new Point (108, 76)),
            new quadruple ('AL_BACKPLANE', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (83, 185))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 34, 189,  98, 198), compRiser),
            new AnArea (new Rect (174, 188, 268, 210), compRedundantPower),
            new AnArea (new Rect (  4, 188, 166, 210), compIOConnector)
        ),
        new Tuple (
            new quadruple ('AL_POWERS', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_POWERS'], new Point (212, 191))
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('h',
        "parent.I18N['BACKPLANE']", "(parent.once.theFRUInfo ? parent.once.findFRU(17, 2, 6) : '')"
    ),

    new GSysViewHealth ('f',
        "parent.I18N['BACKPLANE']", "(parent.once.theFRUInfo ? parent.once.findFRU(17, 2, 6) : '')",
        "parent.I18N['BACKPLANE_NUMBER']", "1",
        "parent.I18N['USB_PORT']", "2"
    ),
    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "2",
        "parent.I18N['MAN_LAN_PORT']", "'1 ' + parent.I18N['OPTIONAL_PORT']",
        "parent.I18N['USB_PORT']", "2",
        "parent.I18N['POWERMODULE']", "2"
    )
);

//////////////////////////////////////////////
// The System Backplane structure

var theSysBackplane = new Array ();

theSysBackplane[parent.asLbID['ASWM_SNRGROUP_BACKPLANE1']] = new SysBackplane (
    'BP4LX-F14-R12', 'h_bp.jpg', compBackplane,
    new Tuple,
    new Tuple (
        new Tuple (snridBkplBay1Plug),
        new Tuple (snridBkplBay2Plug),
        new Tuple (snridBkplBay3Plug),
        new Tuple (snridBkplBay4Plug)
    ),
    new triple (parent.asID['ASWM_CFGGROUP_ASMA'] << 16, parent.asID['ASWM_SNRGROUP_BACKPLANE1'] << 16, parent.asID['ASWM_CFGTYPE_BACKPLANE'])
);

var theSysPower = new SysPower (
    '_', compRedundantPower,
    new Tuple (
        new Tuple (snridPower1Plug, snridPower1DC, snridPower1AC, snridPowerFan1),
        new Tuple (snridPower2Plug, snridPower2DC, snridPower2AC, snridPowerFan2)
    ),
    false
);
